## ungleich-hardware

This container is made for configuring hardware on our clusters.
It usually needs to run in privileged mode.

The source repository for this container is
on
[code.ungleich.ch](https://code.ungleich.ch/ungleich-public/ungleich-hardware). This
image uses significant content from the
[hwraid](https://hwraid.le-vert.net/) page that we would like to thank
for its years long contribution.

See also the [ungleich hardware maintenance
guide](https://redmine.ungleich.ch/projects/open-infrastructure/wiki/The_ungleich_hardware_maintenance_guide),
which describes the use of various hardware raid tools.

You can use this image from

* ungleich/ungleich-hardware
* harbor.ungleich.svc.p10.k8s.ooo/ungleich-public/ungleich-hardware
  (IPv6 only)

## Included tools

```
cciss_vol_status
dmidecode
fwupd(mgr)
hdparm
hpacucli
ipmitool
lspci
megacli
megaclisas-status
mpt-status
ps
strace
stress-ng
tmux
```

## Usage

### Kubernetes

To enable access to devices and give permission to the pod to use it,
you could use:

```
apiVersion: v1
kind: Pod
metadata:
  name: ungleich-hardware
spec:
  containers:
  - name: ungleich-hardware
    image: harbor.ungleich.svc.p10.k8s.ooo/ungleich-public/ungleich-hardware:0.0.1
    args:
    - sleep
    - "1000000"
    volumeMounts:
      - mountPath: /dev
        name: dev
    securityContext:
      privileged: true
  volumes:
    - name: dev
      hostPath:
        path: /dev
```

You might want to schedule the pod on a specific system, which you can
use using the nodeSelector:

```
...
  nodeSelector:
    kubernetes.io/hostname: "server49"
....
```

### fwupdmgr

```
/usr/bin/dbus-daemon --system --address=systemd: --nopidfile  --syslog-only
```

### hpacucli

Ensure the following kernel modules are loaded on the host:

```
hpsa
sg
```

to avoid the

```
# hpacucli controller all show

Error: No controllers detected.
```

error.

## Changelog / Tags

### 0.1.0 (planned)

* Include storcli
  https://docs.broadcom.com/docs-and-downloads/raid-controllers/raid-controllers-common-files/1.23.02_StorCLI.zip
* include megacli.py for prometheus supprt
  https://github.com/ungleich/megacli2prom

### 0.0.5 (2022-01-15)

* Added procps for ps
* Added tmux to be able to run things in parallel

### 0.0.4 (2022-01-15)

* Added strace

### 0.0.3 (2022-01-15)

* Added pciutils, mpt-status
* Added fwupd (need to solve/document dbus issue)

### 0.0.2 (2022-01-15)

* Added dmidecode

### 0.0.1 (2022-01-15)

* Initial release
